# RakNet::VariableDeltaSerializer Class Reference

Class to compare memory values of variables in a current state to a prior state Results of the comparisons will be written to a bitStream, such that only changed variables get written
Can be used with ReplicaManager3 to Serialize a Replica3 per-variable, rather than comparing the entire object against itself
Usage:
BR> 1. Call BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize(). In the case of Replica3, this would be in the Serialize() call
2. For each variable of the type in step 1, call Serialize(). The same variables must be serialized every tick()
3. Call EndSerialize()
4. Repeat step 1 for each of the other categories of how to send varaibles. More...

`#include <VariableDeltaSerializer.h>`

List of all members.

## Public Member Functions
void | BeginUnreliableAckedSerialize (SerializationContext *context, RakNetGUID _guid, BitStream *_bitStream, uint32_t _sendReceipt)
| Call before doing one or more SerializeVariable calls when the data will be sent UNRELIABLE_WITH_ACK_RECEIPT The last value of each variable will be saved per remote system. Additionally, a history of _sendReceipts is stored to determine what to resend on packetloss. When variables are lost, they will be flagged dirty and always resent to the system that lost it Disadvantages: Every variable for every remote system is copied internally, in addition to a history list of what variables changed for which _sendReceipt. Very memory and CPU intensive for multiple connections. Advantages: When data needs to be resent by RakNet, RakNet can only resend the value it currently has. This allows the application to control the resend, sending the most recent value of the variable. The end result is that bandwidth is used more efficiently because old data is never sent.
void | BeginUniqueSerialize (SerializationContext *context, RakNetGUID _guid, BitStream *_bitStream)
| Call before doing one or more SerializeVariable calls for data that may be sent differently to every remote system (such as an invisibility flag that only teammates can see) The last value of each variable will be saved per remote system. Unlike BeginUnreliableAckedSerialize(), send receipts are not necessary Disadvantages: Every variable for every remote system is copied internally. Very memory and CPU intensive for multiple connections. Advantages: When data is sent differently depending on the recipient, this system can make things easier to use and is as efficient as it can be.
void | BeginIdenticalSerialize (SerializationContext *context, bool _isFirstSerializeToThisSystem, BitStream *_bitStream)
| Call before doing one or more SerializeVariable calls for data that is sent with the same value to every remote system (such as health, position, etc.) This is the most common type of serialization, and also the most efficient Disadvantages: A copy of every variable still needs to be held, although only once Advantages: After the first serialization, the last serialized bitStream will be used for subsequent sends.
void | EndSerialize (SerializationContext *context)
| Call after BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize(), then after calling SerializeVariable() one or more times.
void | BeginDeserialize (DeserializationContext *context, BitStream *_bitStream)
| Call when you receive the BitStream written by SerializeVariable(), before calling DeserializeVariable().
void | EndDeserialize (DeserializationContext *context)
void | AddRemoteSystemVariableHistory (RakNetGUID guid)
void | RemoveRemoteSystemVariableHistory (RakNetGUID guid)
void | OnPreSerializeTick (void)
void | OnMessageReceipt (RakNetGUID guid, uint32_t receiptId, bool messageArrived)
template<class VarType >
void | SerializeVariable (SerializationContext *context, const VarType &variable)
template<class VarType >
bool | DeserializeVariable (DeserializationContext *context, VarType &variable)
## Protected Attributes
DataStructures::List < RemoteSystemVariableHistory * > | remoteSystemVariableHistoryList

## Detailed Description

Class to compare memory values of variables in a current state to a prior state Results of the comparisons will be written to a bitStream, such that only changed variables get written
Can be used with ReplicaManager3 to Serialize a Replica3 per-variable, rather than comparing the entire object against itself
Usage:
BR> 1. Call BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize(). In the case of Replica3, this would be in the Serialize() call
2. For each variable of the type in step 1, call Serialize(). The same variables must be serialized every tick()
3. Call EndSerialize()
4. Repeat step 1 for each of the other categories of how to send varaibles.

On the receiver:

1. Call BeginDeserialize(). In the case of Replica3, this would be in the Deserialize() call 2. Call DeserializeVariable() for each variable, in the same order as was Serialized() 3. Call EndSerialize()

See also:
  The ReplicaManager3 sample

## Member Function Documentation

void RakNet::VariableDeltaSerializer::AddRemoteSystemVariableHistory | ( | RakNetGUID | guid | ) |

BeginUnreliableAckedSerialize() and BeginUniqueSerialize() require knowledge of when connections are added and dropped Call AddRemoteSystemVariableHistory() and RemoveRemoteSystemVariableHistory() to notify the system of these events

Parameters:

  `[in]` | _guid | Which system we are sending to

void RakNet::VariableDeltaSerializer::BeginDeserialize | ( | DeserializationContext * | context,
|  | BitStream * | _bitStream |
| ) |  |  |

Call when you receive the BitStream written by SerializeVariable(), before calling DeserializeVariable().

Parameters:

  `[in]` | context | Holds the context of this group of deserialize calls. This can be a stack object just passed to the function.
  `[in]` | _bitStream | Pass the bitStream originally passed to and written to by serialize calls

void RakNet::VariableDeltaSerializer::BeginIdenticalSerialize | ( | SerializationContext * | context,
|  | bool | _isFirstSerializeToThisSystem,
|  | BitStream * | _bitStream |
| ) |  |  |

Call before doing one or more SerializeVariable calls for data that is sent with the same value to every remote system (such as health, position, etc.) This is the most common type of serialization, and also the most efficient Disadvantages: A copy of every variable still needs to be held, although only once Advantages: After the first serialization, the last serialized bitStream will be used for subsequent sends.

Precondition:
  Call OnPreSerializeTick() before doing any calls to BeginIdenticalSerialize() for each of your objects, once per game tick

Parameters:

  `[in]` | context | Holds the context of this group of serialize calls. This can be a stack object just passed to the function.
  `[in]` | _isFirstSerializeToThisSystem | Pass true if this is the first time ever serializing to this system (the initial download). This way all variables will be written, rather than checking against prior sent values.
  `[in]` | _bitSteam | Which bitStream to write to

void RakNet::VariableDeltaSerializer::BeginUniqueSerialize | ( | SerializationContext * | context,
|  | RakNetGUID | _guid,
|  | BitStream * | _bitStream |
| ) |  |  |

Call before doing one or more SerializeVariable calls for data that may be sent differently to every remote system (such as an invisibility flag that only teammates can see) The last value of each variable will be saved per remote system. Unlike BeginUnreliableAckedSerialize(), send receipts are not necessary Disadvantages: Every variable for every remote system is copied internally. Very memory and CPU intensive for multiple connections. Advantages: When data is sent differently depending on the recipient, this system can make things easier to use and is as efficient as it can be.

Precondition:
  AddRemoteSystemVariableHistory() and RemoveRemoteSystemVariableHistory() must be called for new and lost connections

Parameters:

  `[in]` | context | Holds the context of this group of serialize calls. This can be a stack object just passed to the function.
  `[in]` | _guid | Which system we are sending to
  `[in]` | _bitSteam | Which bitStream to write to

void RakNet::VariableDeltaSerializer::BeginUnreliableAckedSerialize | ( | SerializationContext * | context,
|  | RakNetGUID | _guid,
|  | BitStream * | _bitStream,
|  | uint32_t | _sendReceipt |
| ) |  |  |

Call before doing one or more SerializeVariable calls when the data will be sent UNRELIABLE_WITH_ACK_RECEIPT The last value of each variable will be saved per remote system. Additionally, a history of _sendReceipts is stored to determine what to resend on packetloss. When variables are lost, they will be flagged dirty and always resent to the system that lost it Disadvantages: Every variable for every remote system is copied internally, in addition to a history list of what variables changed for which _sendReceipt. Very memory and CPU intensive for multiple connections. Advantages: When data needs to be resent by RakNet, RakNet can only resend the value it currently has. This allows the application to control the resend, sending the most recent value of the variable. The end result is that bandwidth is used more efficiently because old data is never sent.

Precondition:
  Upon getting ID_SND_RECEIPT_LOSS or ID_SND_RECEIPT_ACKED call OnMessageReceipt()

  AddRemoteSystemVariableHistory() and RemoveRemoteSystemVariableHistory() must be called for new and lost connections

Parameters:

  `[in]` | context | Holds the context of this group of serialize calls. This can be a stack object just passed to the function.
  `[in]` | _guid | Which system we are sending to
  `[in]` | _bitSteam | Which bitStream to write to
  `[in]` | _sendReceipt | Returned from RakPeer::IncrementNextSendReceipt() and passed to the Send() or SendLists() function. Identifies this update for ID_SND_RECEIPT_LOSS and ID_SND_RECEIPT_ACKED

template<class VarType >

bool RakNet::VariableDeltaSerializer::DeserializeVariable | ( | DeserializationContext * | context,
|  | VarType & | variable |
| ) |  |  | `[inline]`

Call to deserialize into a variable

Precondition:
  You have called BeginDeserialize()

Note:
  Be sure to call EndDeserialize() after finishing all deserializations

Parameters:

  `[in]` | context | Same context pointer passed to BeginDeserialize()
  `[in]` | variable | A variable to write to the bitStream passed to context

void RakNet::VariableDeltaSerializer::EndDeserialize | ( | DeserializationContext * | context | ) |

Parameters:

  `[in]` | context | Same context pointer passed to BeginDeserialize()

void RakNet::VariableDeltaSerializer::EndSerialize | ( | SerializationContext * | context | ) |

Call after BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize(), then after calling SerializeVariable() one or more times.

Parameters:

  `[in]` | context | Same context pointer passed to BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize()

void RakNet::VariableDeltaSerializer::OnMessageReceipt | ( | RakNetGUID | guid,
|  | uint32_t | receiptId,
|  | bool | messageArrived |
| ) |  |  |

Call when getting ID_SND_RECEIPT_LOSS or ID_SND_RECEIPT_ACKED for a particular system Example:

uint32_t msgNumber; memcpy(&msgNumber, packet->data+1, 4); DataStructures::Multilist<ML_STACK, Replica3*> replicaListOut; replicaManager.GetReplicasCreatedByMe(replicaListOut); DataStructures::DefaultIndexType idx; for (idx=0; idx < replicaListOut.GetSize(); idx++) { ((SampleReplica*)replicaListOut[idx])->NotifyReplicaOfMessageDeliveryStatus(packet->guid,msgNumber, packet->data[0]==ID_SND_RECEIPT_ACKED); }

Parameters:

  `[in]` | guid | Which system we are sending to
  `[in]` | receiptId | Encoded in bytes 1-4 inclusive of ID_SND_RECEIPT_LOSS and ID_SND_RECEIPT_ACKED
  `[in]` | messageArrived | True for ID_SND_RECEIPT_ACKED, false otherwise

void RakNet::VariableDeltaSerializer::OnPreSerializeTick | ( | void |  | ) |

BeginIdenticalSerialize() requires knowledge of when serialization has started for an object across multiple systems This way it can setup the flag to do new comparisons against the last sent values, rather than just resending the last sent bitStream For Replica3, overload and call this from Replica3::OnUserReplicaPreSerializeTick()

void RakNet::VariableDeltaSerializer::RemoveRemoteSystemVariableHistory | ( | RakNetGUID | guid | ) |

BeginUnreliableAckedSerialize() and BeginUniqueSerialize() require knowledge of when connections are added and dropped Call AddRemoteSystemVariableHistory() and RemoveRemoteSystemVariableHistory() to notify the system of these events

Parameters:

  `[in]` | _guid | Which system we are sending to

template<class VarType >

void RakNet::VariableDeltaSerializer::SerializeVariable | ( | SerializationContext * | context,
|  | const VarType & | variable |
| ) |  |  | `[inline]`

Call to Serialize a variable Will write to the bitSteam passed to context true, variableValue if the variable has changed or has never been written. Otherwise will write false.

Precondition:
  You have called BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize()

  Will also require calling OnPreSerializeTick() if using BeginIdenticalSerialize()

Note:
  Be sure to call EndSerialize() after finishing all serializations

Parameters:

  `[in]` | context | Same context pointer passed to BeginUnreliableAckedSerialize(), BeginUniqueSerialize(), or BeginIdenticalSerialize()
  `[in]` | variable | A variable to write to the bitStream passed to context

## Member Data Documentation

DataStructures::List<RemoteSystemVariableHistory*> RakNet::VariableDeltaSerializer::remoteSystemVariableHistoryList`[protected]`

A list of RemoteSystemVariableHistory indexed by guid, one per connection that we serialize to List is added to when SerializeConstruction is called, and removed from when SerializeDestruction is called, or when a given connection is dropped

The documentation for this class was generated from the following file:

- d:/RakNet-3.x/Source/VariableDeltaSerializer.h